import { TekGrid } from '@zeedhi/teknisa-components-common';
import { Metadata, Http } from '@zeedhi/core';
import {
    LoadingService, TextInput, IGridEvent,
} from '@zeedhi/common';
import { Utilities } from '@/util/Utilities';

export class PartnerClassificationController {
    public addPartnerClassification() {
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid');
        // const newId = (grid.datasource.total + 1).toString();
        const newId = 0;

        grid.addNewRow({ NRTPCLASSIFICAPARC: newId }, 'start');
        setTimeout(() => {
            const nameInput = Metadata.getInstance<TextInput>(`NMCLASSIFICAPARC_editable_${newId}`);
            nameInput.setFocus();
        }, 100);
    }

    public async insertPartnerClassification({ event }: IGridEvent) {
        event!.preventDefault();
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid');
        const classifications = grid.getEditedRows();
        LoadingService.show();
            try {
                await Http.post('/insertNewPartnerClassification', classifications);
                await grid.cancelEditedRows();
                await grid.reload();
                Utilities.showSuccessMessage();
            } catch (e) {
                Utilities.showErrorMessage(e);
            }
        LoadingService.hide();
    }

    public async deletePartnerClassification({ event }: IGridEvent) {
        event!.preventDefault();
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid');
        LoadingService.show();
        try {
            await Http.post('/deletePartnerClassification', grid.selectedRows);
            await grid.cancelEditedRows();
            await grid.reload();
            Utilities.showSuccessMessage();
        } catch (e) {
            Utilities.showErrorMessage(e);
        }
        LoadingService.hide();
    }
}
